import { IconDefinition } from "@fortawesome/pro-solid-svg-icons"
import { MoveType, Orientation } from "@prisma/client"

export interface Position {
  x: number
  y: number
}
export interface Target extends Position {
  show: boolean
}
export interface TargetPreview extends Target {
  orientation: Orientation
}
export interface MouseCursor extends Position {
  shouldShow: boolean
}
export interface TargetList extends Position {
  type: string
  edges: string[]
}
export interface Mode {
  pointerGrid: any[][]
  type: MoveType
}
export interface ItemProps {
  icon: string | IconDefinition
  text: string
  amount?: number
  iconColor?: string
  disabled?: boolean
  callback?: () => void
}
export interface EventBarModes {
  main: ItemProps[]
  menu: ItemProps[]
  actions: ItemProps[]
  draw: ItemProps[]
  settings: ItemProps[]
}
export interface Field extends Position {
  field: string
}
export interface Hit extends Position {
  hit: boolean
}
export interface Point extends Position {}
export interface DrawLineProps {
  currentPoint: Point
  prevPoint: Point | null
  color: string
}
export interface Draw extends DrawLineProps {
  ctx: CanvasRenderingContext2D
}
export interface ShipProps extends Position {
  size: number
  variant: number
  orientation: Orientation
}
export interface IndexedPosition extends Position {
  i?: number
}
export interface ActionDispatchProps extends Position {
  index?: number
  action: MoveType
}
